require "defines"
require "util"
--[[desc: 
blocks building of more than 1 rocket launcher 
if rocket silo is built evolution goes to .999 and on every x (defautl 3) second an attack on a given search discante (def: 10 chunks) is commanded to all biters
if rocket silo dies or is removed evolution goes back, and enemy wander (as the loose their target)
-- in "includes" the initial scan mods scanning also 10 chunks.
]]--
--define
local unit_search_distance = 32*15 -- radius = 999 chunks = infty.
local evolution_if_active=0.999
local update_attack_time = 3 *60  -- 60 ticks per second.
--init
local target_rocket_launcher=nil
local evol_old=0.0
local next_event_tick=update_attack_time  -- time when to update attack


script.on_event(defines.events.on_robot_built_entity, function(event) con(event) end)
script.on_event(defines.events.on_built_entity, function(event) con(event) end)
script.on_event(defines.events.on_entity_died, function(event) died(event) end)
script.on_event(defines.events.on_robot_mined, function(event) decon(event) end)
script.on_event(defines.events.on_player_mined_item, function(event) decon(event) end)
script.on_event(defines.events.on_tick, function(event) doTick(event) end)

-- construction deconstruction

function con(event)
	if event.created_entity.name== "rocket-silo" then
		if not target_rocket_launcher then
			target_rocket_launcher=event.created_entity
			game.show_message_dialog{text = "You hear a scream so loud, you almost loose your mind..."}
			evol_old=game.evolution_factor 
			game.evolution_factor =math.max(evolution_if_active,game.evolution_factor )
			doAttack(event)
			--fprintf('rs created')
			else
		event.created_entity.destroy() -- only 1 rlauncher allowe	
			end

		
	end
end
function died(event)
	if event.entity.name== "rocket-silo" then
	target_rocket_launcher=nil
	game.evolution_factor =evol_old
	--fprintf('rs died')
	end
end
function decon(event)

	if event.item_stack then
		if event.item_stack.name== "rocket-silo" then
			target_rocket_launcher=nil
			game.evolution_factor =evol_old
			--fprintf('rs decons')
		end
	end
end
function doTick(event)
--fprintf("tick",event.tick)
if (event.tick>=next_event_tick) then
	--fprintf("target time", next_event_tick)
	--fprintf("actual time", event.tick)
	next_event_tick=event.tick+update_attack_time
	doAttack(event)
end
end
function doAttack(event)
	if target_rocket_launcher then
		assert(target_rocket_launcher.name=="rocket-silo")
	 
	 their_army=target_rocket_launcher.surface.find_enemy_units(target_rocket_launcher.position,  unit_search_distance) 
	for k,unit_k in pairs(their_army) do   
		--unit_k.set_command( {type=defines.command.attack_area	, destination =event.created_entity.position, radius=attack_radius, distraction=defines.distraction.by_enemy})  
		unit_k.set_command({type=defines.command.attack	,target=target_rocket_launcher, distraction=defines.distraction.by_enemy})   
	end
	-- fprintf("numenemies iterated", #their_army) 
	-- fprintf("attack cmd issued to",event.created_entity.name)  
	 
	 -- multi command does work bad... only a few or almost no enemies are pushed. , only active chunks, but not "polluted chunks" 4
	 -- local num_units = 1000
	 -- event.created_entity.surface.set_multi_command{command = {type=defines.command.attack, target=event.created_entity, distraction=defines.distraction.by_enemy},unit_count = num_units, unit_search_distance= search_area_radius}
	 -- distration=none didn't help either.
	 
	end -- < if rocket-silo>
end --fcn



function fprintf(message,numbuild)
			game.player.print(tostring(message)..":"..tostring(numbuild))
end


--[[known issues:

units getting stuck in forrests (forget their command, and are seemingly not effected by new events)
units on connected land mass, where the direct path is blocked by water often get stuck at the coast
multi-command is not working (as expected)
the attack command should be issued on a periodic timer (1s-10s) or should be connected to some "on_unit_created(type=biter/spitter)"

]]--
require "defines"
 
if remote.interfaces.freeplay then
    script.on_event( defines.events.on_player_created, function( event )
    local i = event.player_index	
	chart_map(i)
end)
end

function chart_map(i)
		local p = game.players[i]
		local f = p.force
		local s = p.surface
		local Chunks_To_Scan = {}
		local settings = s.map_gen_settings.starting_area
		
			if settings == "none" then 
				Chunks_To_Scan = 0
				end
			if settings == "very-small" then 
				Chunks_To_Scan = 3
				end
			if settings == "small" then 
				Chunks_To_Scan = 4
				end
			if settings == "medium" then 
				Chunks_To_Scan = 5
				end
			if settings == "big" then 
				Chunks_To_Scan = 6
				end
			if settings == "very-big" then 
				Chunks_To_Scan = 7
				end

    Chunks_To_Scan =10
	-- To set a custom scan size, uncomment above and input your own value
		
	local S = Chunks_To_Scan*32
	
	fprintf("initial scan: ",Chunks_To_Scan)
	end
	